<?php

require_once('api/Simpla.php');
require_once('help.class.php');

class PayKeeper extends Simpla
{
	public function checkout_form($order_id, $button_text = null)
	{



		if (empty($button_text))
			$button_text = 'Перейти к оплате';

		$order = $this->orders->get_order((int)$order_id);
		$payment_method = $this->payment->get_payment_method($order->payment_method_id);
		$payment_settings = $this->payment->get_payment_settings($payment_method->id);


		//////////////////////////////////////
		// $phone = preg_replace('/[^\d]/', '', $order->phone);
		// $phone = substr($phone, -min(10, strlen($phone)), 10);

		$pk_obj             = new PaykeeperPayment();
        $pk_obj->setOrderParams
        (
            //sum
            $this->money->convert($order->total_price, $payment_method->currency_id, false),
            //clientid
            $order->name,
            //orderid
            $order->id,
            //client_email
            $order->email,
            //client_phone
            $order->phone,
            //service_name
            'paykeeper_payment_system',
            //payment form url
            $payment_settings["payment_url"],
            //secret key
            $payment_settings["secret_word"]
        );
        //print_r($payment_settings);
		$query = $this->db->placehold("SELECT * FROM __purchases WHERE order_id=$order_id ORDER BY id");
		$this->db->query($query);
        $cart_array = $this->db->results();
        $item_index =   0;
        $item_type  =   $payment_settings["item_type"];
        $tax        =   $payment_settings["tax"];
		if ($tax!='none')$pk_obj->setUseTaxes();
       //Собираем корзину в хелпер
	   foreach ($cart_array as $item) 
	   {
		   $price      = $this->money->convert($item->price, $payment_method->currency_id, false);
		   $quantity   = $item->amount;
		   $sum        = $price*$quantity;
		   $name       = mb_substr(html_entity_decode($item->product_name . ($item->variant_name ? ' ' . $item->variant_name : '')), 0, 512);
		   if ($quantity == 1 && $pk_obj->single_item_index < 0)
				$pk_obj->single_item_index = $item_index;
		   if ($quantity > 1 && $pk_obj->more_then_one_item_index < 0)
			   $pk_obj->more_then_one_item_index = $item_index;
		   $pk_obj->updateFiscalCart($pk_obj->getPaymentFormType(),
					   $name, $price, $quantity, $sum, $tax,$item_type);
		   $item_index++;   
	   }
	   //Добавляем доставку в хелпер
	   if($order->delivery_id && $order->delivery_price > 0)
	   {
		   $delivery               = $this->delivery->get_delivery($order->delivery_id);
		   $delivery_name          = $delivery->name;            
		   $pk_obj->setShippingPrice(floatval($this->money->convert($order->delivery_price, $payment_method->currency_id, false)));
		   $pk_obj->setUseDelivery();
		   $pk_obj->delivery_index = count($pk_obj->getFiscalCart());
		   $pk_obj->updateFiscalCart($pk_obj->getPaymentFormType(), $delivery_name,
						   $pk_obj->getShippingPrice(), 1, $pk_obj->getShippingPrice(), 'none',"service");

		   $item_index++;
	   }
	   $pk_obj->correctPrecision();
	   $fiscal_cart_encoded = json_encode($pk_obj->getFiscalCart());
	   if ($pk_obj->getPaymentFormType() == "create") 
	   {
		   $to_hash = number_format($pk_obj->getOrderTotal(), 2, ".", "") .
					  $pk_obj->getOrderParams("clientid")     .
					  $pk_obj->getOrderParams("orderid")      .
					  $pk_obj->getOrderParams("service_name") .
					  $pk_obj->getOrderParams("client_email") .
					  $pk_obj->getOrderParams("client_phone") .
					  $pk_obj->getOrderParams("secret_key");
		   $sign = hash ('sha256' , $to_hash);
	   }


	   $paymentForm = 
	   '<form name="payment" id="pay_form" action="'.$pk_obj->getOrderParams("form_url").'" accept-charset="utf-8" method="post">
	   <input type="hidden" name="sum" value = "'.$pk_obj->getOrderTotal().'"/>
	   <input type="hidden" name="orderid" value = "'.$pk_obj->getOrderParams("orderid").'"/>
	   <input type="hidden" name="clientid" value = "'.$pk_obj->getOrderParams("clientid").'"/>
	   <input type="hidden" name="client_email" value = "'.$pk_obj->getOrderParams("client_email").'"/>
	   <input type="hidden" name="client_phone" value = "'.$pk_obj->getOrderParams("client_phone").'"/>
	   <input type="hidden" name="service_name" value = "'.$pk_obj->getOrderParams("service_name").'"/>
	   <input type="hidden" name="cart" value = \''.htmlentities($fiscal_cart_encoded,ENT_QUOTES).'\' />
	   <input type="hidden" name="sign" value = "'.$sign.'"/>
	   <input type="submit" id="button-confirm" class ="checkout_button"value="Оплатить"/>
	   </form>';
	   return $paymentForm;
	}
}
